#****************************************************************************
#**
#**  Author(s):  Exavier Macbeth
#**
#**  Summary  :  BlackOps: Adv Command Unit - Aeon ACU
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local AWalkingLandUnit = import('/lua/aeonunits.lua').AWalkingLandUnit

local AWeapons = import('/lua/aeonweapons.lua')
local ADFDisruptorCannonWeapon = AWeapons.ADFDisruptorCannonWeapon
local AIFCommanderDeathWeapon = AWeapons.AIFCommanderDeathWeapon
local EffectTemplate = import('/lua/EffectTemplates.lua')
local EffectUtil = import('/lua/EffectUtilities.lua')
local Weapon = import('/lua/sim/Weapon.lua').Weapon
local ADFOverchargeWeapon = AWeapons.ADFOverchargeWeapon
local ADFChronoDampener = AWeapons.ADFChronoDampener
local Buff = import('/lua/sim/Buff.lua')
local CSoothSayerAmbient = import('/lua/EffectTemplates.lua').CSoothSayerAmbient
local AIFArtilleryMiasmaShellWeapon = import('/lua/aeonweapons.lua').AIFArtilleryMiasmaShellWeapon
local AANChronoTorpedoWeapon = import('/lua/aeonweapons.lua').AANChronoTorpedoWeapon
local ADFPhasonLaser = import('/lua/aeonweapons.lua').ADFPhasonLaser
local AeonACUPhasonLaser = import('/mods/BlackOpsACUs/lua/EXBlackOpsweapons.lua').AeonACUPhasonLaser 
local AIFQuasarAntiTorpedoWeapon = AWeapons.AIFQuasarAntiTorpedoWeapon
local EXCEMPArrayBeam01 = import('/mods/BlackOpsACUs/lua/EXBlackOpsweapons.lua').EXCEMPArrayBeam01 
local AAMWillOWisp = import('/lua/aeonweapons.lua').AAMWillOWisp


local EXQuantumMaelstromWeapon = Class(Weapon) {

    OnFire = function(self)
        local blueprint = self:GetBlueprint()
        DamageArea(self.unit, self.unit:GetPosition(), blueprint.DamageRadius,
                   blueprint.Damage, blueprint.DamageType, blueprint.DamageFriendly)
    end,
}
EAL0001 = Class(AWalkingLandUnit) {

    DeathThreadDestructionWaitTime = 2,

    Weapons = {
        DeathWeapon = Class(AIFCommanderDeathWeapon) {},
        EXTargetPainter = Class(EXCEMPArrayBeam01) {
            OnWeaponFired = function(self)
				EXCEMPArrayBeam01.OnWeaponFired(self)
				local mypos = self.unit:GetPosition()
				local targetpos = self:GetCurrentTargetPos()
				local targetdistance = VDist3(mypos,targetpos)
				if self.unit.wcArtillery01 then
					if (targetdistance >= 25) then
						self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', true)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
					else
						self.unit:SetWeaponEnabledByLabel('RightDisruptor', true)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
					end
				elseif self.unit.wcArtillery02 then
					if (targetdistance >= 25) then
						self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', true)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
					else
						self.unit:SetWeaponEnabledByLabel('RightDisruptor', true)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
					end
				elseif self.unit.wcArtillery03 then
					if (targetdistance >= 25) then
						self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', true)
					else
						self.unit:SetWeaponEnabledByLabel('RightDisruptor', true)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
						self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
					end
				elseif self.unit.wcBeam01 then
					self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam01', true)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam02', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam03', false)
				elseif self.unit.wcBeam02 then
					self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam01', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam02', true)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam03', false)
				elseif self.unit.wcBeam03 then
					self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam01', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam02', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam03', true)
				elseif not self.unit.wcArtillery01 and not self.unit.wcArtillery02 and not self.unit.wcArtillery03 and not self.unit.wcBeam01 and not self.unit.wcBeam02 and not self.unit.wcBeam03 then
					self.unit:SetWeaponEnabledByLabel('RightDisruptor', true)
					self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
					self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
					self.unit:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam01', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam02', false)
					self.unit:SetWeaponEnabledByLabel('EXPhasonBeam03', false)
				end
            end,	
		},
        RightDisruptor = Class(ADFDisruptorCannonWeapon) {},
        EXChronoDampener01 = Class(ADFChronoDampener) {},
        EXChronoDampener02 = Class(ADFChronoDampener) {},
        EXTorpedoLauncher01 = Class(AANChronoTorpedoWeapon) {},
        EXTorpedoLauncher02 = Class(AANChronoTorpedoWeapon) {},
        EXTorpedoLauncher03 = Class(AANChronoTorpedoWeapon) {},
        EXMiasmaArtillery01 = Class(AIFArtilleryMiasmaShellWeapon) {},
        EXMiasmaArtillery02 = Class(AIFArtilleryMiasmaShellWeapon) {},
        EXMiasmaArtillery03 = Class(AIFArtilleryMiasmaShellWeapon) {},
        EXPhasonBeam01 = Class(AeonACUPhasonLaser) {},
        EXPhasonBeam02 = Class(AeonACUPhasonLaser) {},
        EXPhasonBeam03 = Class(AeonACUPhasonLaser) {},
        EXQuantumMaelstrom01 = Class(EXQuantumMaelstromWeapon) {},
        EXQuantumMaelstrom02 = Class(EXQuantumMaelstromWeapon) {},
        EXQuantumMaelstrom03 = Class(EXQuantumMaelstromWeapon) {},
        EXAntiTorpedo = Class(AIFQuasarAntiTorpedoWeapon) {},
        EXAntiMissile = Class(AAMWillOWisp) {},
        OverCharge = Class(ADFOverchargeWeapon) {

            OnCreate = function(self)
                ADFOverchargeWeapon.OnCreate(self)
                self:SetWeaponEnabled(false)
                self.AimControl:SetEnabled(false)
                self.AimControl:SetPrecedence(0)
				self.unit:SetOverchargePaused(false)
            end,

            OnEnableWeapon = function(self)
                if self:BeenDestroyed() then return end
                ADFOverchargeWeapon.OnEnableWeapon(self)
                self:SetWeaponEnabled(true)
                self.unit:SetWeaponEnabledByLabel('RightDisruptor', false)
                self.unit:BuildManipulatorSetEnabled(false)
                self.AimControl:SetEnabled(true)
                self.AimControl:SetPrecedence(20)
                self.unit.BuildArmManipulator:SetPrecedence(0)
                self.AimControl:SetHeadingPitch( self.unit:GetWeaponManipulatorByLabel('RightDisruptor'):GetHeadingPitch() )
            end,

            OnWeaponFired = function(self)
                ADFOverchargeWeapon.OnWeaponFired(self)
                self:OnDisableWeapon()
                self:ForkThread(self.PauseOvercharge)
            end,
            
            OnDisableWeapon = function(self)
                if self.unit:BeenDestroyed() then return end
                self:SetWeaponEnabled(false)
                self.unit:SetWeaponEnabledByLabel('RightDisruptor', true)
                self.unit:BuildManipulatorSetEnabled(false)
                self.AimControl:SetEnabled(false)
                self.AimControl:SetPrecedence(0)
                self.unit.BuildArmManipulator:SetPrecedence(0)
                self.unit:GetWeaponManipulatorByLabel('RightDisruptor'):SetHeadingPitch( self.AimControl:GetHeadingPitch() )
            end,
            
            PauseOvercharge = function(self)
                if not self.unit:IsOverchargePaused() then
                    self.unit:SetOverchargePaused(true)
                    WaitSeconds(1/self:GetBlueprint().RateOfFire)
                    self.unit:SetOverchargePaused(false)
                end
            end,
            
            OnFire = function(self)
                if not self.unit:IsOverchargePaused() then
                    ADFOverchargeWeapon.OnFire(self)
                end
            end,
            IdleState = State(ADFOverchargeWeapon.IdleState) {
                OnGotTarget = function(self)
                    if not self.unit:IsOverchargePaused() then
                        ADFOverchargeWeapon.IdleState.OnGotTarget(self)
                    end
                end,            
                OnFire = function(self)
                    if not self.unit:IsOverchargePaused() then
                        ChangeState(self, self.RackSalvoFiringState)
                    end
                end,
            },
            RackSalvoFireReadyState = State(ADFOverchargeWeapon.RackSalvoFireReadyState) {
                OnFire = function(self)
                    if not self.unit:IsOverchargePaused() then
                        ADFOverchargeWeapon.RackSalvoFireReadyState.OnFire(self)
                    end
                end,
            },              
        },
    },


    OnCreate = function(self)
        AWalkingLandUnit.OnCreate(self)
        self:SetCapturable(false)
        self:SetupBuildBones()
        # Restrict what enhancements will enable later
        self:AddBuildRestriction( categories.AEON * (categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
        self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )
    end,

    OnPrepareArmToBuild = function(self)
        AWalkingLandUnit.OnPrepareArmToBuild(self)
        if self:BeenDestroyed() then return end
        self:BuildManipulatorSetEnabled(true)
        self.BuildArmManipulator:SetPrecedence(20)
        self.wcBuildMode = true
		self:ForkThread(self.WeaponConfigCheck)
        self.BuildArmManipulator:SetHeadingPitch( self:GetWeaponManipulatorByLabel('RightDisruptor'):GetHeadingPitch() )
    end,

    OnStopCapture = function(self, target)
        AWalkingLandUnit.OnStopCapture(self, target)
        if self:BeenDestroyed() then return end
        self:BuildManipulatorSetEnabled(false)
        self.BuildArmManipulator:SetPrecedence(0)
        self.wcBuildMode = false
		self:ForkThread(self.WeaponConfigCheck)
        self:GetWeaponManipulatorByLabel('RightDisruptor'):SetHeadingPitch( self.BuildArmManipulator:GetHeadingPitch() )
    end,

    OnFailedCapture = function(self, target)
        AWalkingLandUnit.OnFailedCapture(self, target)
        if self:BeenDestroyed() then return end
        self:BuildManipulatorSetEnabled(false)
        self.BuildArmManipulator:SetPrecedence(0)
        self.wcBuildMode = false
		self:ForkThread(self.WeaponConfigCheck)
        self:GetWeaponManipulatorByLabel('RightDisruptor'):SetHeadingPitch( self.BuildArmManipulator:GetHeadingPitch() )
    end,

    OnStopReclaim = function(self, target)
        AWalkingLandUnit.OnStopReclaim(self, target)
        if self:BeenDestroyed() then return end
        self:BuildManipulatorSetEnabled(false)
        self.BuildArmManipulator:SetPrecedence(0)
        self.wcBuildMode = false
		self:ForkThread(self.WeaponConfigCheck)
        self:GetWeaponManipulatorByLabel('RightDisruptor'):SetHeadingPitch( self.BuildArmManipulator:GetHeadingPitch() )
    end,

    OnStopBeingBuilt = function(self,builder,layer)
        AWalkingLandUnit.OnStopBeingBuilt(self,builder,layer)
        self:DisableUnitIntel('RadarStealth')
        self:DisableUnitIntel('SonarStealth')
        self:DisableUnitIntel('Cloak')
        self:DisableUnitIntel('CloakField')
		self:HideBone('Engineering', true)
		self:HideBone('Combat_Engineering', true)
		self:HideBone('Left_Turret_Plates', true)
		self:HideBone('Basic_GunUp_Range', true)
		self:HideBone('Basic_GunUp_RoF', true)
		self:HideBone('Torpedo_Launcher', true)
		self:HideBone('Laser_Cannon', true)
		self:HideBone('IntelPack_Torso', true)
		self:HideBone('IntelPack_Head', true)
		self:HideBone('IntelPack_LShoulder', true)
		self:HideBone('IntelPack_RShoulder', true)
		self:HideBone('DamagePack_LArm', true)
		self:HideBone('DamagePack_RArm', true)
		self:HideBone('DamagePack_Torso', true)
		self:HideBone('DamagePack_RLeg_B01', true)
		self:HideBone('DamagePack_RLeg_B02', true)
		self:HideBone('DamagePack_LLeg_B01', true)
		self:HideBone('DamagePack_LLeg_B02', true)
		self:HideBone('ShieldPack_Normal', true)
		self:HideBone('Shoulder_Arty_L', true)
		self:HideBone('ShieldPack_Arty_LArm', true)
		self:HideBone('Shoulder_Arty_R', true)
		self:HideBone('ShieldPack_Arty_RArm', true)
		self:HideBone('Artillery_Torso', true)
		self:HideBone('ShieldPack_Artillery', true)
		self:HideBone('Artillery_Barrel_Left', true)
		self:HideBone('Artillery_Barrel_Right', true)
		self:HideBone('Artillery_Pitch', true)
		self.ccShield = false
		self.ccArtillery = false
		self.wcBuildMode = false
		self.wcOCMode = false
		self.wcChrono01 = false
		self.wcChrono02 = false
		self.wcTorp01 = false
		self.wcTorp02 = false
		self.wcTorp03 = false
		self.wcArtillery01 = false
		self.wcArtillery02 = false
		self.wcArtillery03 = false
		self.wcBeam01 = false
		self.wcBeam02 = false
		self.wcBeam03 = false
		self.wcMaelstrom01 = false
		self.wcMaelstrom02 = false
		self.wcMaelstrom03 = false
		local wepPainter = self:GetWeaponByLabel('EXTargetPainter')
		wepPainter:ChangeMaxRadius(22)
		self:ForkThread(self.WeaponConfigCheck)
		self:ForkThread(self.WeaponRangeReset)
		self.MaelstromEffects01 = {}
        self:ForkThread(self.GiveInitialResources)
        self.ShieldEffectsBag = {}
    end,

    OnFailedToBuild = function(self)
        AWalkingLandUnit.OnFailedToBuild(self)
        if self:BeenDestroyed() then return end
        self:BuildManipulatorSetEnabled(false)
        self.BuildArmManipulator:SetPrecedence(0)
        self.wcBuildMode = false
		self:ForkThread(self.WeaponConfigCheck)
        self:GetWeaponManipulatorByLabel('RightDisruptor'):SetHeadingPitch( self.BuildArmManipulator:GetHeadingPitch() )
    end,
    
    OnStartBuild = function(self, unitBeingBuilt, order)
        AWalkingLandUnit.OnStartBuild(self, unitBeingBuilt, order)
        self.UnitBeingBuilt = unitBeingBuilt
        self.UnitBuildOrder = order
        self.BuildingUnit = true     
    end,

    OnStopBuild = function(self, unitBeingBuilt)
        AWalkingLandUnit.OnStopBuild(self, unitBeingBuilt)
        if self:BeenDestroyed() then return end
        self:BuildManipulatorSetEnabled(false)
        self.BuildArmManipulator:SetPrecedence(0)
        self.wcBuildMode = false
		self:ForkThread(self.WeaponConfigCheck)
        self:GetWeaponManipulatorByLabel('RightDisruptor'):SetHeadingPitch( self.BuildArmManipulator:GetHeadingPitch() )
        self.UnitBeingBuilt = nil
        self.UnitBuildOrder = nil
        self.BuildingUnit = false          
    end,

    GiveInitialResources = function(self)
        WaitTicks(2)
        self:GetAIBrain():GiveResource('Energy', self:GetBlueprint().Economy.StorageEnergy)
        self:GetAIBrain():GiveResource('Mass', self:GetBlueprint().Economy.StorageMass)
    end,
    
    CreateBuildEffects = function( self, unitBeingBuilt, order )
        EffectUtil.CreateAeonCommanderBuildingEffects( self, unitBeingBuilt, self:GetBlueprint().General.BuildBones.BuildEffectBones, self.BuildEffectsBag )
    end,  

    PlayCommanderWarpInEffect = function(self)
        self:HideBone(0, true)
        self:SetUnSelectable(true)
        self:SetBusy(true)
        self:SetBlockCommandQueue(true)
        self:ForkThread(self.WarpInEffectThread)
    end,

    WarpInEffectThread = function(self)
        self:PlayUnitSound('CommanderArrival')
        self:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
        WaitSeconds(2.1)
        self:SetMesh('/mods/BlackopsACUs/units/eal0001/EAL0001_PhaseShield_mesh', true)
        self:ShowBone(0, true)
		self:HideBone('Engineering', true)
		self:HideBone('Combat_Engineering', true)
		self:HideBone('Left_Turret_Plates', true)
		self:HideBone('Basic_GunUp_Range', true)
		self:HideBone('Basic_GunUp_RoF', true)
		self:HideBone('Torpedo_Launcher', true)
		self:HideBone('Laser_Cannon', true)
		self:HideBone('IntelPack_Torso', true)
		self:HideBone('IntelPack_Head', true)
		self:HideBone('IntelPack_LShoulder', true)
		self:HideBone('IntelPack_RShoulder', true)
		self:HideBone('DamagePack_LArm', true)
		self:HideBone('DamagePack_RArm', true)
		self:HideBone('DamagePack_Torso', true)
		self:HideBone('DamagePack_RLeg_B01', true)
		self:HideBone('DamagePack_RLeg_B02', true)
		self:HideBone('DamagePack_LLeg_B01', true)
		self:HideBone('DamagePack_LLeg_B02', true)
		self:HideBone('ShieldPack_Normal', true)
		self:HideBone('Shoulder_Arty_L', true)
		self:HideBone('ShieldPack_Arty_LArm', true)
		self:HideBone('Shoulder_Arty_R', true)
		self:HideBone('ShieldPack_Arty_RArm', true)
		self:HideBone('Artillery_Torso', true)
		self:HideBone('ShieldPack_Artillery', true)
		self:HideBone('Artillery_Barrel_Left', true)
		self:HideBone('Artillery_Barrel_Right', true)
		self:HideBone('Artillery_Pitch', true)
        self:SetUnSelectable(false)
        self:SetBusy(false)        
        self:SetBlockCommandQueue(false)
        local totalBones = self:GetBoneCount() - 1
        local army = self:GetArmy()
        for k, v in EffectTemplate.UnitTeleportSteam01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end

        WaitSeconds(6)
        self:SetMesh(self:GetBlueprint().Display.MeshBlueprint, true)
    end,

    WeaponRangeReset = function(self)
		if not self.wcChrono01 then
			local wepFlamer01 = self:GetWeaponByLabel('EXChronoDampener01')
			wepFlamer01:ChangeMaxRadius(1)
		end
		if not self.wcChrono02 then
			local wepFlamer02 = self:GetWeaponByLabel('EXChronoDampener02')
			wepFlamer02:ChangeMaxRadius(1)
		end
		if not self.wcTorp01 then
			local wepTorpedo01 = self:GetWeaponByLabel('EXTorpedoLauncher01')
			wepTorpedo01:ChangeMaxRadius(1)
		end
		if not self.wcTorp02 then
			local wepTorpedo02 = self:GetWeaponByLabel('EXTorpedoLauncher02')
			wepTorpedo02:ChangeMaxRadius(1)
		end
		if not self.wcTorp03 then
			local wepTorpedo03 = self:GetWeaponByLabel('EXTorpedoLauncher03')
			wepTorpedo03:ChangeMaxRadius(1)
		end
		if not self.wcArtillery01 then
			local wepAntiMatter01 = self:GetWeaponByLabel('EXMiasmaArtillery01')
			wepAntiMatter01:ChangeMaxRadius(1)
		end
		if not self.wcArtillery02 then
			local wepAntiMatter02 = self:GetWeaponByLabel('EXMiasmaArtillery02')
			wepAntiMatter02:ChangeMaxRadius(1)
		end
		if not self.wcArtillery03 then
			local wepAntiMatter03 = self:GetWeaponByLabel('EXMiasmaArtillery03')
			wepAntiMatter03:ChangeMaxRadius(1)
		end
		if not self.wcBeam01 then
			local wepGattling01 = self:GetWeaponByLabel('EXPhasonBeam01')
			wepGattling01:ChangeMaxRadius(1)
		end
		if not self.wcBeam02 then
			local wepGattling02 = self:GetWeaponByLabel('EXPhasonBeam02')
			wepGattling02:ChangeMaxRadius(1)
		end
		if not self.wcBeam03 then
			local wepGattling03 = self:GetWeaponByLabel('EXPhasonBeam03')
			wepGattling03:ChangeMaxRadius(1)
		end
		if not self.wcMaelstrom01 then
			local wepClusterMiss01 = self:GetWeaponByLabel('EXQuantumMaelstrom01')
			wepClusterMiss01:ChangeMaxRadius(1)
		end
		if not self.wcMaelstrom02 then
			local wepClusterMiss02 = self:GetWeaponByLabel('EXQuantumMaelstrom02')
			wepClusterMiss02:ChangeMaxRadius(1)
		end
		if not self.wcMaelstrom03 then
			local wepClusterMiss03 = self:GetWeaponByLabel('EXQuantumMaelstrom03')
			wepClusterMiss03:ChangeMaxRadius(1)
		end
    end,
	
    WeaponConfigCheck = function(self)
		if self.wcBuildMode then
			self:SetWeaponEnabledByLabel('EXTargetPainter', false)
			self:SetWeaponEnabledByLabel('RightDisruptor', false)
			self:SetWeaponEnabledByLabel('OverCharge', false)
			self:SetWeaponEnabledByLabel('EXChronoDampener01', false)
			self:SetWeaponEnabledByLabel('EXChronoDampener02', false)
			self:SetWeaponEnabledByLabel('EXTorpedoLauncher01', false)
			self:SetWeaponEnabledByLabel('EXTorpedoLauncher02', false)
			self:SetWeaponEnabledByLabel('EXTorpedoLauncher03', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam01', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam02', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam03', false)
			self:SetWeaponEnabledByLabel('EXQuantumMaelstrom01', false)
			self:SetWeaponEnabledByLabel('EXQuantumMaelstrom02', false)
			self:SetWeaponEnabledByLabel('EXQuantumMaelstrom03', false)
		end
		if self.wcOCMode then
			self:SetWeaponEnabledByLabel('EXTargetPainter', false)
			self:SetWeaponEnabledByLabel('RightDisruptor', false)
			self:SetWeaponEnabledByLabel('EXChronoDampener01', false)
			self:SetWeaponEnabledByLabel('EXChronoDampener02', false)
			self:SetWeaponEnabledByLabel('EXTorpedoLauncher01', false)
			self:SetWeaponEnabledByLabel('EXTorpedoLauncher02', false)
			self:SetWeaponEnabledByLabel('EXTorpedoLauncher03', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam01', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam02', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam03', false)
		end
		if not self.wcBuildMode and not self.wcOCMode then
			self:SetWeaponEnabledByLabel('EXTargetPainter', true)
			self:SetWeaponEnabledByLabel('RightDisruptor', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery01', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery02', false)
			self:SetWeaponEnabledByLabel('EXMiasmaArtillery03', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam01', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam02', false)
			self:SetWeaponEnabledByLabel('EXPhasonBeam03', false)
			self:SetWeaponEnabledByLabel('OverCharge', false)
			if self.wcChrono01 then
				self:SetWeaponEnabledByLabel('EXChronoDampener01', true)
				local wepFlamer01 = self:GetWeaponByLabel('EXChronoDampener01')
				wepFlamer01:ChangeMaxRadius(22)
			else
				self:SetWeaponEnabledByLabel('EXChronoDampener01', false)
			end
			if self.wcChrono02 then
				self:SetWeaponEnabledByLabel('EXChronoDampener02', true)
				local wepFlamer02 = self:GetWeaponByLabel('EXChronoDampener02')
				wepFlamer02:ChangeMaxRadius(22)
			else
				self:SetWeaponEnabledByLabel('EXChronoDampener02', false)
			end
			if self.wcTorp01 then
				self:SetWeaponEnabledByLabel('EXTorpedoLauncher01', true)
				self:SetWeaponEnabledByLabel('EXAntiTorpedo', true)
				local wepTorpedo01 = self:GetWeaponByLabel('EXTorpedoLauncher01')
				wepTorpedo01:ChangeMaxRadius(60)
			else
				self:SetWeaponEnabledByLabel('EXTorpedoLauncher01', false)
				self:SetWeaponEnabledByLabel('EXAntiTorpedo', false)
			end
			if self.wcTorp02 then
				self:SetWeaponEnabledByLabel('EXTorpedoLauncher02', true)
				self:SetWeaponEnabledByLabel('EXAntiTorpedo', true)
				local wepTorpedo02 = self:GetWeaponByLabel('EXTorpedoLauncher02')
				wepTorpedo02:ChangeMaxRadius(60)
			else
				self:SetWeaponEnabledByLabel('EXTorpedoLauncher02', false)
				self:SetWeaponEnabledByLabel('EXAntiTorpedo', false)
			end
			if self.wcTorp03 then
				self:SetWeaponEnabledByLabel('EXTorpedoLauncher03', true)
				self:SetWeaponEnabledByLabel('EXAntiTorpedo', true)
				local wepTorpedo03 = self:GetWeaponByLabel('EXTorpedoLauncher03')
				wepTorpedo03:ChangeMaxRadius(60)
			else
				self:SetWeaponEnabledByLabel('EXTorpedoLauncher03', false)
				self:SetWeaponEnabledByLabel('EXAntiTorpedo', false)
			end
			if self.wcArtillery01 then
				local wepAntiMatter01 = self:GetWeaponByLabel('EXMiasmaArtillery01')
				wepAntiMatter01:ChangeMaxRadius(100)
			else
				
			end
			if self.wcArtillery02 then
				local wepAntiMatter02 = self:GetWeaponByLabel('EXMiasmaArtillery02')
				wepAntiMatter02:ChangeMaxRadius(100)
			else
				
			end
			if self.wcArtillery03 then
				local wepAntiMatter03 = self:GetWeaponByLabel('EXMiasmaArtillery03')
				wepAntiMatter03:ChangeMaxRadius(100)
			else
				
			end
			if self.wcBeam01 then
				local wepGattling01 = self:GetWeaponByLabel('EXPhasonBeam01')
				wepGattling01:ChangeMaxRadius(35)
			else

			end
			if self.wcBeam02 then

				local wepGattling02 = self:GetWeaponByLabel('EXPhasonBeam02')
				wepGattling02:ChangeMaxRadius(35)
			else

			end
			if self.wcBeam03 then

				local wepGattling03 = self:GetWeaponByLabel('EXPhasonBeam03')
				wepGattling03:ChangeMaxRadius(35)
			else

			end
			if self.wcMaelstrom01 then
				self:SetWeaponEnabledByLabel('EXQuantumMaelstrom01', true)
				local wepClusterMiss01 = self:GetWeaponByLabel('EXQuantumMaelstrom01')
				wepClusterMiss01:ChangeMaxRadius(90)
			else
				self:SetWeaponEnabledByLabel('EXQuantumMaelstrom01', false)
			end
			if self.wcMaelstrom02 then
				self:SetWeaponEnabledByLabel('EXQuantumMaelstrom02', true)
				local wepClusterMiss02 = self:GetWeaponByLabel('EXQuantumMaelstrom02')
				wepClusterMiss02:ChangeMaxRadius(90)
			else
				self:SetWeaponEnabledByLabel('EXQuantumMaelstrom02', false)
			end
			if self.wcMaelstrom03 then
				self:SetWeaponEnabledByLabel('EXQuantumMaelstrom03', true)
				local wepClusterMiss03 = self:GetWeaponByLabel('EXQuantumMaelstrom03')
				wepClusterMiss03:ChangeMaxRadius(90)
			else
				self:SetWeaponEnabledByLabel('EXQuantumMaelstrom03', false)
			end
		end
    end,
	
    ArtyShieldCheck = function(self)
		if self.ccArtillery and not self.ccShield then
			self:HideBone('ShieldPack_Normal', true)
			self:HideBone('Shoulder_Normal_L', true)
			self:HideBone('Shoulder_Normal_R', true)
			self:ShowBone('Shoulder_Arty_L', true)
			self:ShowBone('Shoulder_Arty_R', true)
			self:ShowBone('Artillery_Torso', true)
			self:ShowBone('Artillery_Barrel_Left', true)
			self:ShowBone('Artillery_Barrel_Right', true)
			self:HideBone('ShieldPack_Arty_LArm', true)
			self:HideBone('ShieldPack_Arty_RArm', true)
			self:HideBone('ShieldPack_Artillery', true)
			self:ShowBone('Artillery_Pitch', true)
		elseif self.ccShield and not self.ccArtillery then
			self:ShowBone('ShieldPack_Normal', true)
			self:ShowBone('Shoulder_Normal_L', true)
			self:ShowBone('Shoulder_Normal_R', true)
			self:HideBone('Shoulder_Arty_L', true)
			self:HideBone('Shoulder_Arty_R', true)
			self:HideBone('Artillery_Torso', true)
			self:HideBone('Artillery_Barrel_Left', true)
			self:HideBone('Artillery_Barrel_Right', true)
			self:HideBone('ShieldPack_Arty_LArm', true)
			self:HideBone('ShieldPack_Arty_RArm', true)
			self:HideBone('ShieldPack_Artillery', true)
			self:HideBone('Artillery_Pitch', true)
		elseif self.ccArtillery and self.ccShield then
			self:HideBone('ShieldPack_Normal', true)
			self:HideBone('Shoulder_Normal_L', true)
			self:HideBone('Shoulder_Normal_R', true)
			self:ShowBone('Shoulder_Arty_L', true)
			self:ShowBone('Shoulder_Arty_R', true)
			self:ShowBone('Artillery_Torso', true)
			self:ShowBone('Artillery_Barrel_Left', true)
			self:ShowBone('Artillery_Barrel_Right', true)
			self:ShowBone('ShieldPack_Arty_LArm', true)
			self:ShowBone('ShieldPack_Arty_RArm', true)
			self:ShowBone('ShieldPack_Artillery', true)
			self:ShowBone('Artillery_Pitch', true)
		elseif not self.ccArtillery and not self.ccShield then
			self:HideBone('ShieldPack_Normal', true)
			self:ShowBone('Shoulder_Normal_L', true)
			self:ShowBone('Shoulder_Normal_R', true)
			self:HideBone('Shoulder_Arty_L', true)
			self:HideBone('Shoulder_Arty_R', true)
			self:HideBone('Artillery_Torso', true)
			self:HideBone('Artillery_Barrel_Left', true)
			self:HideBone('Artillery_Barrel_Right', true)
			self:HideBone('ShieldPack_Arty_LArm', true)
			self:HideBone('ShieldPack_Arty_RArm', true)
			self:HideBone('ShieldPack_Artillery', true)
			self:HideBone('Artillery_Pitch', true)
		end
    end,

    OnTransportDetach = function(self, attachBone, unit)
        AWalkingLandUnit.OnTransportDetach(self, attachBone, unit)
		self:StopSiloBuild()
        self:ForkThread(self.WeaponConfigCheck)
    end,

    OnScriptBitClear = function(self, bit)
        if bit == 0 then # shield toggle
			self:DisableShield()
			self:StopUnitAmbientSound( 'ActiveLoop' )
        elseif bit == 8 then # cloak toggle
            self:PlayUnitAmbientSound( 'ActiveLoop' )
            self:SetMaintenanceConsumptionActive()
            self:EnableUnitIntel('Cloak')
            self:EnableUnitIntel('RadarStealth')
            self:EnableUnitIntel('RadarStealthField')
            self:EnableUnitIntel('SonarStealth')
            self:EnableUnitIntel('SonarStealthField')          
        end
    end,

    OnScriptBitSet = function(self, bit)
        if bit == 0 then # shield toggle
			self:EnableShield()
            self:PlayUnitAmbientSound( 'ActiveLoop' )
		elseif bit == 8 then # cloak toggle
            self:StopUnitAmbientSound( 'ActiveLoop' )
            self:SetMaintenanceConsumptionInactive()
            self:DisableUnitIntel('Cloak')
            self:DisableUnitIntel('RadarStealth')
            self:DisableUnitIntel('RadarStealthField')
            self:DisableUnitIntel('SonarStealth')
            self:DisableUnitIntel('SonarStealthField')
        end
    end,

    CreateEnhancement = function(self, enh)
        AWalkingLandUnit.CreateEnhancement(self, enh)
        local bp = self:GetBlueprint().Enhancements[enh]
        if enh =='EXImprovedEngineering' then
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            if not Buffs['AEONACUT2BuildRate'] then
                BuffBlueprint {
                    Name = 'AEONACUT2BuildRate',
                    DisplayName = 'AEONACUT2BuildRate',
                    BuffType = 'ACUBUILDRATE',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        BuildRate = {
                            Add =  bp.NewBuildRate - self:GetBlueprint().Economy.BuildRate,
                            Mult = 1,
                        },
                        Regen = {
                            Add = bp.NewRegenRate,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'AEONACUT2BuildRate')
            local bp = self:GetBlueprint().Enhancements[enh]
            local bpEcon = self:GetBlueprint().Economy
            if not bp then return end
            self:SetProductionPerSecondEnergy(bp.ProductionPerSecondEnergy + bpEcon.ProductionPerSecondEnergy or 0)
            self:SetProductionPerSecondMass(bp.ProductionPerSecondMass + bpEcon.ProductionPerSecondMass or 0)
            if not Buffs['EXHealthBoost1'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost1',
                    DisplayName = 'EXHealthBoost1',
                    BuffType = 'EXHealthBoost1',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost1')
        elseif enh =='EXImprovedEngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if Buff.HasBuff( self, 'AEONACUT2BuildRate' ) then
                Buff.RemoveBuff( self, 'AEONACUT2BuildRate' )
            end
            if not bp then return end
            self:RestoreBuildRestrictions()
            self:AddBuildRestriction( categories.AEON * (categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )
            local bpEcon = self:GetBlueprint().Economy
            self:SetProductionPerSecondEnergy(bpEcon.ProductionPerSecondEnergy or 0)
            self:SetProductionPerSecondMass(bpEcon.ProductionPerSecondMass or 0)
            if Buff.HasBuff( self, 'EXHealthBoost1' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost1' )
            end
        elseif enh =='EXAdvancedEngineering' then
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            if not Buffs['AEONACUT3BuildRate'] then
                BuffBlueprint {
                    Name = 'AEONACUT3BuildRate',
                    DisplayName = 'AEONCUT3BuildRate',
                    BuffType = 'ACUBUILDRATE',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        BuildRate = {
                            Add =  bp.NewBuildRate - self:GetBlueprint().Economy.BuildRate,
                            Mult = 1,
                        },
                        Regen = {
                            Add = bp.NewRegenRate,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'AEONACUT3BuildRate')
            local bp = self:GetBlueprint().Enhancements[enh]
            local bpEcon = self:GetBlueprint().Economy
            if not bp then return end
            self:SetProductionPerSecondEnergy(bp.ProductionPerSecondEnergy + bpEcon.ProductionPerSecondEnergy or 0)
            self:SetProductionPerSecondMass(bp.ProductionPerSecondMass + bpEcon.ProductionPerSecondMass or 0)
            if not Buffs['EXHealthBoost2'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost2',
                    DisplayName = 'EXHealthBoost2',
                    BuffType = 'EXHealthBoost2',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost2')
        elseif enh =='EXAdvancedEngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if not bp then return end
            self:RestoreBuildRestrictions()
            if Buff.HasBuff( self, 'AEONACUT3BuildRate' ) then
                Buff.RemoveBuff( self, 'AEONACUT3BuildRate' )
            end
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )
            local bpEcon = self:GetBlueprint().Economy
            self:SetProductionPerSecondEnergy(bpEcon.ProductionPerSecondEnergy or 0)
            self:SetProductionPerSecondMass(bpEcon.ProductionPerSecondMass or 0)
            if Buff.HasBuff( self, 'EXHealthBoost1' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost1' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost2' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost2' )
            end
        elseif enh =='EXExperimentalEngineering' then
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            if not Buffs['AEONACUT4BuildRate'] then
                BuffBlueprint {
                    Name = 'AEONACUT4BuildRate',
                    DisplayName = 'AEONCUT4BuildRate',
                    BuffType = 'ACUBUILDRATE',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        BuildRate = {
                            Add =  bp.NewBuildRate - self:GetBlueprint().Economy.BuildRate,
                            Mult = 1,
                        },
                        Regen = {
                            Add = bp.NewRegenRate,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'AEONACUT4BuildRate')
            self:SetRegenRate(bp.NewRegenRate)
            if not Buffs['EXHealthBoost3'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost3',
                    DisplayName = 'EXHealthBoost3',
                    BuffType = 'EXHealthBoost3',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost3')
            if not Buffs['EXRegenBoost1'] then
                BuffBlueprint {
                    Name = 'EXRegenBoost1',
                    DisplayName = 'EXRegenBoost1',
                    BuffType = 'EXRegenBoost1',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        Regen = {
                            Add = bp.NewRegenRate2,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXRegenBoost1')
			elseif enh =='EXExperimentalEngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if not bp then return end
            self:RestoreBuildRestrictions()
            if Buff.HasBuff( self, 'AEONACUT4BuildRate' ) then
                Buff.RemoveBuff( self, 'AEONACUT4BuildRate' )
            end
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )
            self:RevertRegenRate()
            if Buff.HasBuff( self, 'EXHealthBoost1' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost1' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost2' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost2' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost3' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost3' )
            end
            if Buff.HasBuff( self, 'EXRegenBoost1' ) then
                Buff.RemoveBuff( self, 'EXRegenBoost1' )
            end
        elseif enh =='EXCombatEngineering' then
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            if not Buffs['AEONACUT2BuildRate'] then
                BuffBlueprint {
                    Name = 'AEONACUT2BuildRate',
                    DisplayName = 'AEONACUT2BuildRate',
                    BuffType = 'ACUBUILDRATE',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        BuildRate = {
                            Add =  bp.NewBuildRate - self:GetBlueprint().Economy.BuildRate,
                            Mult = 1,
                        },
                        Regen = {
                            Add = bp.NewRegenRate,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'AEONACUT2BuildRate')
            if not Buffs['EXHealthBoost4'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost4',
                    DisplayName = 'EXHealthBoost4',
                    BuffType = 'EXHealthBoost4',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost4')
			self.wcChrono01 = true
			self.wcChrono02 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXCombatEngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if Buff.HasBuff( self, 'AEONACUT2BuildRate' ) then
                Buff.RemoveBuff( self, 'AEONACUT2BuildRate' )
            end
            if not bp then return end
            self:RestoreBuildRestrictions()
            self:AddBuildRestriction( categories.AEON * (categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )
            if Buff.HasBuff( self, 'EXHealthBoost4' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost4' )
            end
			self.wcChrono01 = false
			self.wcChrono02 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXAssaultEngineering' then
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            if not Buffs['AEONACUT3BuildRate'] then
                BuffBlueprint {
                    Name = 'AEONACUT3BuildRate',
                    DisplayName = 'AEONCUT3BuildRate',
                    BuffType = 'ACUBUILDRATE',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        BuildRate = {
                            Add =  bp.NewBuildRate - self:GetBlueprint().Economy.BuildRate,
                            Mult = 1,
                        },
                        Regen = {
                            Add = bp.NewRegenRate,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'AEONACUT3BuildRate')
            if not Buffs['EXHealthBoost5'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost5',
                    DisplayName = 'EXHealthBoost5',
                    BuffType = 'EXHealthBoost5',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost5')  
			self.wcChrono01 = false
			self.wcChrono02 = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXAssaultEngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if not bp then return end
            self:RestoreBuildRestrictions()
            if Buff.HasBuff( self, 'AEONACUT3BuildRate' ) then
                Buff.RemoveBuff( self, 'AEONACUT3BuildRate' )
            end
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )     
            if Buff.HasBuff( self, 'EXHealthBoost4' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost4' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost5' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost5' )
            end
			self.wcChrono01 = false
			self.wcChrono02 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXApocolypticEngineering' then
            local cat = ParseEntityCategory(bp.BuildableCategoryAdds)
            self:RemoveBuildRestriction(cat)
            if not Buffs['AEONACUT4BuildRate'] then
                BuffBlueprint {
                    Name = 'AEONACUT4BuildRate',
                    DisplayName = 'AEONCUT4BuildRate',
                    BuffType = 'ACUBUILDRATE',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        BuildRate = {
                            Add =  bp.NewBuildRate - self:GetBlueprint().Economy.BuildRate,
                            Mult = 1,
                        },
                        Regen = {
                            Add = bp.NewRegenRate,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'AEONACUT4BuildRate')
            self:SetRegenRate(bp.NewRegenRate)
            if not Buffs['EXHealthBoost6'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost6',
                    DisplayName = 'EXHealthBoost6',
                    BuffType = 'EXHealthBoost6',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost6')
            if not Buffs['EXRegenBoost2'] then
                BuffBlueprint {
                    Name = 'EXRegenBoost2',
                    DisplayName = 'EXRegenBoost2',
                    BuffType = 'EXRegenBoost2',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        Regen = {
                            Add = bp.NewRegenRate2,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXRegenBoost2')
        elseif enh =='EXApocolypticEngineeringRemove' then
            local bp = self:GetBlueprint().Economy.BuildRate
            if not bp then return end
            self:RestoreBuildRestrictions()
            if Buff.HasBuff( self, 'AEONACUT4BuildRate' ) then
                Buff.RemoveBuff( self, 'AEONACUT4BuildRate' )
            end
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER2COMMANDER + categories.BUILTBYTIER3COMMANDER) )
            self:AddBuildRestriction( categories.AEON * ( categories.BUILTBYTIER4COMMANDER) )
            self:RevertRegenRate()
            if Buff.HasBuff( self, 'EXHealthBoost4' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost4' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost5' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost5' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost6' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost6' )
            end
            if Buff.HasBuff( self, 'EXRegenBoost2' ) then
                Buff.RemoveBuff( self, 'EXRegenBoost2' )
            end
			self.wcChrono01 = false
			self.wcChrono02 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
		elseif enh =='EXDisruptorrBooster' then
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            wepDisruptor:AddDamageMod(bp.ZephyrDamageMod)        
        elseif enh =='EXDisruptorrBoosterRemove' then
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
		elseif enh =='EXDisruptorrEnhancer' then
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            wepDisruptor:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            wepOvercharge:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(35)
			self.DisruptorRange = true
        elseif enh =='EXDisruptorrEnhancerRemove' then
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.DisruptorRange = false
        elseif enh =='EXTorpedoLauncher' then
            if not Buffs['EXHealthBoost7'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost7',
                    DisplayName = 'EXHealthBoost7',
                    BuffType = 'EXHealthBoost7',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost7')
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            wepDisruptor:AddDamageMod(bp.ZephyrDamageMod)        
            wepDisruptor:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            wepOvercharge:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(35)
			self.wcTorp01 = true
			self.wcTorp02 = false
			self.wcTorp03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXTorpedoLauncherRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost7' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost7' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcTorp01 = false
			self.wcTorp02 = false
			self.wcTorp03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
		elseif enh =='EXTorpedoRapidLoader' then
            if not Buffs['EXHealthBoost8'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost8',
                    DisplayName = 'EXHealthBoost8',
                    BuffType = 'EXHealthBoost8',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost8')
			self.wcTorp01 = false
			self.wcTorp02 = true
			self.wcTorp03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXTorpedoRapidLoaderRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost7' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost7' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost8' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost8' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcTorp01 = false
			self.wcTorp02 = false
			self.wcTorp03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
		elseif enh =='EXTorpedoClusterLauncher' then
            if not Buffs['EXHealthBoost9'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost9',
                    DisplayName = 'EXHealthBoost9',
                    BuffType = 'EXHealthBoost9',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost9')
			self.wcTorp01 = false
			self.wcTorp02 = false
			self.wcTorp03 = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXTorpedoClusterLauncherRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost7' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost7' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost8' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost8' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost9' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost9' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcTorp01 = false
			self.wcTorp02 = false
			self.wcTorp03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXArtilleryMiasma' then
            if not Buffs['EXHealthBoost10'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost10',
                    DisplayName = 'EXHealthBoost10',
                    BuffType = 'EXHealthBoost10',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost10')
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            wepDisruptor:AddDamageMod(bp.ZephyrDamageMod)        
            wepDisruptor:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            wepOvercharge:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(100)
			self.wcArtillery01 = true
			self.wcArtillery02 = false
			self.wcArtillery03 = false
			self.ccArtillery = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh =='EXArtilleryMiasmaRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost10' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost10' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcArtillery01 = false
			self.wcArtillery02 = false
			self.wcArtillery03 = false
			self.ccArtillery = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh =='EXAdvancedShells' then
            if not Buffs['EXHealthBoost11'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost11',
                    DisplayName = 'EXHealthBoost11',
                    BuffType = 'EXHealthBoost11',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost11')
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            wepDisruptor:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			self.wcArtillery01 = false
			self.wcArtillery02 = true
			self.wcArtillery03 = false
			self.ccArtillery = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh =='EXAdvancedShellsRemove' then    
			self:RemoveToggleCap('RULEUTC_WeaponToggle')
            if Buff.HasBuff( self, 'EXHealthBoost10' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost10' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost11' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost11' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcArtillery01 = false
			self.wcArtillery02 = false
			self.wcArtillery03 = false
			self.ccArtillery = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh =='EXImprovedReloader' then
            if not Buffs['EXHealthBoost12'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost12',
                    DisplayName = 'EXHealthBoost12',
                    BuffType = 'EXHealthBoost12',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost12')
			self.wcArtillery01 = false
			self.wcArtillery02 = false
			self.wcArtillery03 = true
			self.ccArtillery = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh =='EXImprovedReloaderRemove' then    
			self:RemoveToggleCap('RULEUTC_WeaponToggle')
            if Buff.HasBuff( self, 'EXHealthBoost10' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost10' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost11' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost11' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost12' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost12' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcArtillery01 = false
			self.wcArtillery02 = false
			self.wcArtillery03 = false
			self.ccArtillery = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh =='EXBeamPhason' then
            if not Buffs['EXHealthBoost13'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost13',
                    DisplayName = 'EXHealthBoost13',
                    BuffType = 'EXHealthBoost13',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost13')
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            wepDisruptor:AddDamageMod(bp.ZephyrDamageMod)        
            wepDisruptor:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            wepOvercharge:ChangeMaxRadius(bp.ZephyrRangeMod or 44)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(35)
			self.wcBeam01 = true
			self.wcBeam02 = false
			self.wcBeam03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXBeamPhasonRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost13' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost13' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcBeam01 = false
			self.wcBeam02 = false
			self.wcBeam03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXImprovedCoolingSystem' then
            if not Buffs['EXHealthBoost14'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost14',
                    DisplayName = 'EXHealthBoost14',
                    BuffType = 'EXHealthBoost14',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost14')
            self.wcBeam01 = false
			self.wcBeam02 = true
			self.wcBeam03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)    
        elseif enh =='EXImprovedCoolingSystemRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost13' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost13' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost14' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost14' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcBeam01 = false
			self.wcBeam02 = false
			self.wcBeam03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXPowerBooster' then
            if not Buffs['EXHealthBoost15'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost15',
                    DisplayName = 'EXHealthBoost15',
                    BuffType = 'EXHealthBoost15',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost15')
            self.wcBeam01 = false
			self.wcBeam02 = false
			self.wcBeam03 = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXPowerBoosterRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost13' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost13' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost14' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost14' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost15' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost15' )
            end
            local wepDisruptor = self:GetWeaponByLabel('RightDisruptor')
            local bpDisruptGattlingRadius = self:GetBlueprint().Weapon[8].MaxRadius
            local bpDisruptZephyrRadius = self:GetBlueprint().Weapon[2].MaxRadius
            wepDisruptor:ChangeMaxRadius(bpDisruptZephyrRadius or 22)
            wepDisruptor:AddDamageMod(-bp.ZephyrDamageMod)
			local wepOvercharge = self:GetWeaponByLabel('OverCharge')
            local bpDisruptOCRadius = self:GetBlueprint().Weapon[3].MaxRadius
            wepOvercharge:ChangeMaxRadius(bpDisruptOCRadius or 22)
			local wepTargetPainter = self:GetWeaponByLabel('EXTargetPainter')
			wepTargetPainter:ChangeMaxRadius(22)
			self.wcBeam01 = false
			self.wcBeam02 = false
			self.wcBeam03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh == 'EXShieldBattery' then
            self:AddToggleCap('RULEUTC_ShieldToggle')
            self:CreatePersonalShield(bp)
            self:SetEnergyMaintenanceConsumptionOverride(bp.MaintenanceConsumptionPerSecondEnergy or 0)
            self:SetMaintenanceConsumptionActive()
			self.ccShield = true
			self:ForkThread(self.ArtyShieldCheck)
		elseif enh == 'EXShieldBatteryRemove' then
            self:DestroyShield()
            RemoveUnitEnhancement(self, 'EXShieldBatteryRemove')
            self:SetMaintenanceConsumptionInactive()
            self:RemoveToggleCap('RULEUTC_ShieldToggle')
			self.ccShield = false
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh == 'EXActiveShielding' then
            self:DestroyShield()
            ForkThread(function()
                WaitTicks(1)
				self:CreatePersonalShield(bp)
            end)
            self:SetEnergyMaintenanceConsumptionOverride(bp.MaintenanceConsumptionPerSecondEnergy or 0)
            self:SetMaintenanceConsumptionActive()
			self.ccShield = true
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh == 'EXActiveShieldingRemove' then
            self:DestroyShield()
            RemoveUnitEnhancement(self, 'EXActiveShieldingRemove')
            self:SetMaintenanceConsumptionInactive()
            self:RemoveToggleCap('RULEUTC_ShieldToggle')
			self.ccShield = false
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh == 'EXImprovedShieldBattery' then
            self:DestroyShield()
            ForkThread(function()
                WaitTicks(1)
				self:CreatePersonalShield(bp)
            end)
            self:SetEnergyMaintenanceConsumptionOverride(bp.MaintenanceConsumptionPerSecondEnergy or 0)
            self:SetMaintenanceConsumptionActive()
			self:SetWeaponEnabledByLabel('EXAntiMissile', true)
			self.ccShield = true
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh == 'EXImprovedShieldBatteryRemove' then
            self:DestroyShield()
            RemoveUnitEnhancement(self, 'EXImprovedShieldBatteryRemove')
            self:SetMaintenanceConsumptionInactive()
            self:RemoveToggleCap('RULEUTC_ShieldToggle')
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
			self.ccShield = false
			self:ForkThread(self.ArtyShieldCheck)
        elseif enh == 'EXElectronicsEnhancment' then
            self:SetIntelRadius('Vision', bp.NewVisionRadius or 50)
            self:SetIntelRadius('Omni', bp.NewOmniRadius or 50)
            if not Buffs['EXHealthBoost16'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost16',
                    DisplayName = 'EXHealthBoost16',
                    BuffType = 'EXHealthBoost16',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost16')
			self:SetWeaponEnabledByLabel('EXAntiMissile', true)
        elseif enh == 'EXElectronicsEnhancmentRemove' then
            local bpIntel = self:GetBlueprint().Intel
            self:SetIntelRadius('Vision', bpIntel.VisionRadius or 26)
            self:SetIntelRadius('Omni', bpIntel.OmniRadius or 26)
            if Buff.HasBuff( self, 'EXHealthBoost16' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost16' )
            end
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
        elseif enh == 'EXElectronicCountermeasures' then
            self:AddToggleCap('RULEUTC_CloakToggle')
            if self.IntelEffectsBag then
                EffectUtil.CleanupEffectBag(self,'IntelEffectsBag')
                self.IntelEffectsBag = nil
            end
            self.CloakEnh = false        
            self.StealthEnh = true
            self:EnableUnitIntel('RadarStealth')
            self:EnableUnitIntel('SonarStealth')
            self:AddCommandCap('RULEUCC_Teleport')
            if not Buffs['EXHealthBoost17'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost17',
                    DisplayName = 'EXHealthBoost17',
                    BuffType = 'EXHealthBoost17',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost17')
        elseif enh == 'EXElectronicCountermeasuresRemove' then
            self:RemoveToggleCap('RULEUTC_CloakToggle')
            self:DisableUnitIntel('RadarStealth')
            self:DisableUnitIntel('SonarStealth')           
            self.StealthEnh = false
            self.CloakEnh = false 
            self.StealthFieldEffects = false
            self.CloakingEffects = false     
            self:RemoveCommandCap('RULEUCC_Teleport')
            local bpIntel = self:GetBlueprint().Intel
            self:SetIntelRadius('Vision', bpIntel.VisionRadius or 26)
            self:SetIntelRadius('Omni', bpIntel.OmniRadius or 26)
            if Buff.HasBuff( self, 'EXHealthBoost16' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost16' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost17' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost17' )
            end
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
        elseif enh == 'EXCloakingSubsystems' then
            local bp = self:GetBlueprint().Enhancements[enh]
            if not bp then return end
            self.StealthEnh = false
			self.CloakEnh = true 
            self:EnableUnitIntel('Cloak')
            if not Buffs['EXHealthBoost18'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost18',
                    DisplayName = 'EXHealthBoost18',
                    BuffType = 'EXHealthBoost18',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost18')
        elseif enh == 'EXCloakingSubsystemsRemove' then
            self:RemoveToggleCap('RULEUTC_CloakToggle')
            self:DisableUnitIntel('Cloak')
            self.CloakEnh = false 
            self:RemoveCommandCap('RULEUCC_Teleport')
            local bpIntel = self:GetBlueprint().Intel
            self:SetIntelRadius('Vision', bpIntel.VisionRadius or 26)
            self:SetIntelRadius('Omni', bpIntel.OmniRadius or 26)
            if Buff.HasBuff( self, 'EXHealthBoost16' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost16' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost17' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost17' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost18' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost18' )
            end
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
        elseif enh =='EXMaelstromQuantum' then
				if self.MaelstromEffects01 then
					for k, v in self.MaelstromEffects01 do
						v:Destroy()
					end
					self.MaelstromEffects01 = {}
				end
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'Torso', self:GetArmy(), '/mods/BlackopsACUs/effects/emitters/exmaelstrom_aura_01_emit.bp' ):ScaleEmitter(1):OffsetEmitter(0, -2, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'Torso', self:GetArmy(), '/mods/BlackopsACUs/effects/emitters/exmaelstrom_aura_02_emit.bp' ):ScaleEmitter(1):OffsetEmitter(0, -2.75, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LArm', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_02_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.05, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LArm', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_03_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.05, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LArm', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_04_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.05, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RArm', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_02_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.05, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RArm', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_03_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.05, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RArm', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_04_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.05, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RLeg_B01', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_02_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.1, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RLeg_B01', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_03_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.1, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RLeg_B01', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_04_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.1, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RLeg_B02', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_02_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.15, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RLeg_B02', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_03_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.15, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_RLeg_B02', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_04_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.15, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LLeg_B01', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_02_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.1, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LLeg_B01', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_03_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.1, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LLeg_B01', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_04_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.1, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LLeg_B02', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_02_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.15, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LLeg_B02', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_03_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.15, 0) )
				table.insert( self.MaelstromEffects01, CreateAttachedEmitter( self, 'DamagePack_LLeg_B02', self:GetArmy(), '/effects/emitters/seraphim_being_built_ambient_04_emit.bp' ):ScaleEmitter(0.35):OffsetEmitter(0, -0.15, 0) )
            if not Buffs['EXHealthBoost19'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost19',
                    DisplayName = 'EXHealthBoost19',
                    BuffType = 'EXHealthBoost19',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost19')
			self.wcMaelstrom01 = true
			self.wcMaelstrom02 = false
			self.wcMaelstrom03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
        elseif enh =='EXMaelstromQuantumRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost19' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost19' )
            end
			self.wcMaelstrom01 = false
			self.wcMaelstrom02 = false
			self.wcMaelstrom03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
				if self.MaelstromEffects01 then
					for k, v in self.MaelstromEffects01 do
						v:Destroy()
					end
					self.MaelstromEffects01 = {}
				end
        elseif enh =='EXFieldExpander' then
            if not Buffs['EXHealthBoost20'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost20',
                    DisplayName = 'EXHealthBoost20',
                    BuffType = 'EXHealthBoost20',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost20')
			self:SetWeaponEnabledByLabel('EXAntiMissile', true)
            self.wcMaelstrom01 = false
			self.wcMaelstrom02 = true
			self.wcMaelstrom03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)    
        elseif enh =='EXQuantumInstability' then
            if not Buffs['EXHealthBoost21'] then
                BuffBlueprint {
                    Name = 'EXHealthBoost21',
                    DisplayName = 'EXHealthBoost21',
                    BuffType = 'EXHealthBoost21',
                    Stacks = 'REPLACE',
                    Duration = -1,
                    Affects = {
                        MaxHealth = {
                            Add = bp.NewHealth,
                            Mult = 1.0,
                        },
                    },
                }
            end
            Buff.ApplyBuff(self, 'EXHealthBoost21')
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
            self.wcMaelstrom01 = false
			self.wcMaelstrom02 = false
			self.wcMaelstrom03 = true
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)      
        elseif enh == 'EXFieldExpanderRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost19' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost19' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost20' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost20' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost21' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost21' )
            end
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
            self.wcMaelstrom01 = false
			self.wcMaelstrom02 = false
			self.wcMaelstrom03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
				if self.MaelstromEffects01 then
					for k, v in self.MaelstromEffects01 do
						v:Destroy()
					end
					self.MaelstromEffects01 = {}
				end
        elseif enh == 'EXQuantumInstabilityRemove' then
            if Buff.HasBuff( self, 'EXHealthBoost19' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost19' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost20' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost20' )
            end
            if Buff.HasBuff( self, 'EXHealthBoost21' ) then
                Buff.RemoveBuff( self, 'EXHealthBoost21' )
            end
			self:SetWeaponEnabledByLabel('EXAntiMissile', false)
            self.wcMaelstrom01 = false
			self.wcMaelstrom02 = false
			self.wcMaelstrom03 = false
			self:ForkThread(self.WeaponRangeReset)
			self:ForkThread(self.WeaponConfigCheck)
				if self.MaelstromEffects01 then
					for k, v in self.MaelstromEffects01 do
						v:Destroy()
					end
					self.MaelstromEffects01 = {}
				end
        end
    end,

    IntelEffects = {
		Cloak = {
		    {
			    Bones = {
				    'Head',
--				    'Right_Turret',
--				    'Left_Turret',
				    'Right_Arm_B01',
				    'Left_Arm_B01',
				    'Torso',
--				    'Chest_Left',
				    'Left_Leg_B01',
				    'Left_Leg_B02',
				    'Right_Leg_B01',
				    'Right_Leg_B02',
			    },
			    Scale = 1.0,
			    Type = 'Cloak01',
		    },
		},
		Field = {
		    {
			    Bones = {
				    'Head',
--				    'Right_Turret',
--				    'Left_Turret',
				    'Right_Arm_B01',
				    'Left_Arm_B01',
				    'Torso',
--				    'Chest_Left',
				    'Left_Leg_B01',
				    'Left_Leg_B02',
				    'Right_Leg_B01',
				    'Right_Leg_B02',
			    },
			    Scale = 1.6,
			    Type = 'Cloak01',
		    },	
        },	
    },
	
    OnIntelEnabled = function(self)
        AWalkingLandUnit.OnIntelEnabled(self)
        if self.CloakEnh and self:IsIntelEnabled('Cloak') then 
            self:SetEnergyMaintenanceConsumptionOverride(self:GetBlueprint().Enhancements['EXCloakingSubsystems'].MaintenanceConsumptionPerSecondEnergy or 0)
            self:SetMaintenanceConsumptionActive()
            if not self.IntelEffectsBag then
			    self.IntelEffectsBag = {}
			    self.CreateTerrainTypeEffects( self, self.IntelEffects.Cloak, 'FXIdle',  self:GetCurrentLayer(), nil, self.IntelEffectsBag )
			end            
        elseif self.StealthEnh and self:IsIntelEnabled('RadarStealth') and self:IsIntelEnabled('SonarStealth') then
            self:SetEnergyMaintenanceConsumptionOverride(self:GetBlueprint().Enhancements['EXElectronicCountermeasures'].MaintenanceConsumptionPerSecondEnergy or 0)
            self:SetMaintenanceConsumptionActive()  
            if not self.IntelEffectsBag then 
	            self.IntelEffectsBag = {}
		        self.CreateTerrainTypeEffects( self, self.IntelEffects.Field, 'FXIdle',  self:GetCurrentLayer(), nil, self.IntelEffectsBag )
		    end                  
        end		
    end,

    OnIntelDisabled = function(self)
        AWalkingLandUnit.OnIntelDisabled(self)
        if self.IntelEffectsBag then
            EffectUtil.CleanupEffectBag(self,'IntelEffectsBag')
            self.IntelEffectsBag = nil
        end
        if self.CloakEnh and not self:IsIntelEnabled('Cloak') then
            self:SetMaintenanceConsumptionInactive()
        elseif self.StealthEnh and not self:IsIntelEnabled('RadarStealth') and not self:IsIntelEnabled('SonarStealth') then
            self:SetMaintenanceConsumptionInactive()
        end         
    end,

    OnPaused = function(self)
        AWalkingLandUnit.OnPaused(self)
        if self.BuildingUnit then
            AWalkingLandUnit.StopBuildingEffects(self, self:GetUnitBeingBuilt())
        end    
    end,
    
    OnUnpaused = function(self)
        if self.BuildingUnit then
            AWalkingLandUnit.StartBuildingEffects(self, self:GetUnitBeingBuilt(), self.UnitBuildOrder)
        end
        AWalkingLandUnit.OnUnpaused(self)
    end,     

}

TypeClass = EAL0001